/* =========================================================
 * bootstrap-datepicker.js
 * http://www.eyecon.ro/bootstrap-datepicker
 * =========================================================
 * Copyright 2012 Stefan Petre
 * Improvements by Andrew Rowls
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ========================================================= */

!function(d){var m=function(a,b){this.element=d(a);this.language=b.language||this.element.data("date-language")||"en";this.language=this.language in n?this.language:"en";this.format=g.parseFormat(b.format||this.element.data("date-format")||"mm/dd/yyyy");this.picker=d(g.template).appendTo("body").on({click:d.proxy(this.click,this),mousedown:d.proxy(this.mousedown,this)});this.isInput=this.element.is("input");if((this.component=this.element.is(".date")?this.element.find(".add-on"):!1)&&0===this.component.length)this.component=
!1;if(this.isInput)this.element.on({focus:d.proxy(this.show,this),blur:d.proxy(this._hide,this),keyup:d.proxy(this.update,this),keydown:d.proxy(this.keydown,this)});else if(this.component)this.element.find("input").on({focus:d.proxy(this.show,this),blur:d.proxy(this._hide,this),keyup:d.proxy(this.update,this),keydown:d.proxy(this.keydown,this)}),this.component.on("click",d.proxy(this.show,this)),a=this.element.find("input"),a.on({blur:d.proxy(this._hide,this)});else this.element.on("click",d.proxy(this.show,
this));this.autoclose=!1;"autoclose"in b?this.autoclose=b.autoclose:"dateAutoclose"in this.element.data()&&(this.autoclose=this.element.data("date-autoclose"));this.keyboardNavigation=!0;"keyboardNavigation"in b?this.keyboardNavigation=b.keyboardNavigation:"dateKeyboardNavigation"in this.element.data()&&(this.keyboardNavigation=this.element.data("date-keyboard-navigation"));switch(b.startView||this.element.data("date-start-view")){case 2:case "decade":this.viewMode=this.startViewMode=2;break;case 1:case "year":this.viewMode=
this.startViewMode=1;break;default:this.viewMode=this.startViewMode=0}this.weekStart=(b.weekStart||this.element.data("date-weekstart")||n[this.language].weekStart||0)%7;this.weekEnd=(this.weekStart+6)%7;this.startDate=-Infinity;this.endDate=Infinity;this.setStartDate(b.startDate||this.element.data("date-startdate"));this.setEndDate(b.endDate||this.element.data("date-enddate"));this.fillDow();this.fillMonths();this.update();this.showMode()};m.prototype={constructor:m,show:function(a){this.picker.show();
this.height=this.component?this.component.outerHeight():this.element.outerHeight();this.update();this.place();d(window).on("resize",d.proxy(this.place,this));a&&(a.stopPropagation(),a.preventDefault());if(!this.isInput)d(document).on("mousedown",d.proxy(this.hide,this));this.element.trigger({type:"show",date:this.date})},_hide:function(a){if(d.browser.msie){var b=this,c=arguments,e=function(){clearTimeout(l);a.target.focus();b.picker.off("click",e)};this.picker.on("click",e);var l=setTimeout(function(){b.hide.apply(b,
c);b.picker.off("click",e)},100)}else return this.hide.apply(this,arguments)},hide:function(a){this.picker.hide();d(window).off("resize",this.place);this.viewMode=this.startViewMode;this.showMode();this.isInput||d(document).off("mousedown",this.hide);a&&a.currentTarget.value&&this.setValue();this.element.trigger({type:"hide",date:this.date})},setValue:function(){var a=g.formatDate(this.date,this.format,this.language);this.isInput?this.element.prop("value",a):(this.component&&this.element.find("input").prop("value",
a),this.element.data("date",a))},setStartDate:function(a){this.startDate=a||-Infinity;-Infinity!==this.startDate&&(this.startDate=g.parseDate(this.startDate,this.format,this.language));this.update();this.updateNavArrows()},setEndDate:function(a){this.endDate=a||Infinity;Infinity!==this.endDate&&(this.endDate=g.parseDate(this.endDate,this.format,this.language));this.update();this.updateNavArrows()},place:function(){var a=parseInt(this.element.parents().filter(function(){return"auto"!=d(this).css("z-index")}).first().css("z-index"))+
10,b=this.component?this.component.offset():this.element.offset();this.picker.css({top:b.top+this.height,left:b.left,zIndex:a})},update:function(){this.date=g.parseDate(this.isInput?this.element.prop("value"):this.element.data("date")||this.element.find("input").prop("value"),this.format,this.language);this.viewDate=this.date<this.startDate?new Date(this.startDate):this.date>this.endDate?new Date(this.endDate):new Date(this.date);this.fill()},fillDow:function(){for(var a=this.weekStart,b="<tr>";a<
this.weekStart+7;)b+='<th class="dow">'+n[this.language].daysMin[a++%7]+"</th>";this.picker.find(".datepicker-days thead").append(b+"</tr>")},fillMonths:function(){for(var a="",b=0;12>b;)a+='<span class="month">'+n[this.language].monthsShort[b++]+"</span>";this.picker.find(".datepicker-months td").html(a)},fill:function(){var a=new Date(this.viewDate),b=a.getFullYear(),c=a.getMonth(),a=-Infinity!==this.startDate?this.startDate.getFullYear():-Infinity,e=-Infinity!==this.startDate?this.startDate.getMonth():
-Infinity,l=Infinity!==this.endDate?this.endDate.getFullYear():Infinity,d=Infinity!==this.endDate?this.endDate.getMonth():Infinity,k=this.date.valueOf();this.picker.find(".datepicker-days th:eq(1)").text(n[this.language].months[c]+" "+b);this.updateNavArrows();this.fillMonths();var f=new Date(b,c-1,28,0,0,0,0),h=g.getDaysInMonth(f.getFullYear(),f.getMonth()),q,m=0;f.setDate(h);f.setDate(h-(f.getDay()-this.weekStart+7)%7);var r=new Date(f);r.setDate(r.getDate()+42);for(var r=r.valueOf(),h=[],p;f.valueOf()<
r;){f.getDay()==this.weekStart&&h.push("<tr>");p="";if(f.getFullYear()<b||f.getFullYear()==b&&f.getMonth()<c)p+=" old";else if(f.getFullYear()>b||f.getFullYear()==b&&f.getMonth()>c)p+=" new";f.valueOf()==k&&(p+=" active");if(f.valueOf()<this.startDate||f.valueOf()>this.endDate)p+=" disabled";q=f.getDate();-1==m&&q++;h.push('<td class="day'+p+'">'+q+"</td>");f.getDay()==this.weekEnd&&h.push("</tr>");q=f.getDate();f.setDate(f.getDate()+1);0!=f.getHours()&&(m?(-1==m?f.setHours(24):f.setHours(0),f.setMinutes(0),
m=0):m=f.getDate()==q?-1:1)}this.picker.find(".datepicker-days tbody").empty().append(h.join(""));c=this.date.getFullYear();h=this.picker.find(".datepicker-months").find("th:eq(1)").text(b).end().find("span").removeClass("active");c==b&&h.eq(this.date.getMonth()).addClass("active");(b<a||b>l)&&h.addClass("disabled");b==a&&h.slice(0,e).addClass("disabled");b==l&&h.slice(d+1).addClass("disabled");h="";b=10*parseInt(b/10,10);e=this.picker.find(".datepicker-years").find("th:eq(1)").text(b+"-"+(b+9)).end().find("td");
b-=1;for(d=-1;11>d;d++)h+='<span class="year'+(-1==d||10==d?" old":"")+(c==b?" active":"")+(b<a||b>l?" disabled":"")+'">'+b+"</span>",b+=1;e.html(h)},updateNavArrows:function(){var a=new Date(this.viewDate),b=a.getFullYear(),a=a.getMonth();switch(this.viewMode){case 0:-Infinity!==this.startDate&&b<=this.startDate.getFullYear()&&a<=this.startDate.getMonth()?this.picker.find(".prev").css({visibility:"hidden"}):this.picker.find(".prev").css({visibility:"visible"});Infinity!==this.endDate&&b>=this.endDate.getFullYear()&&
a>=this.endDate.getMonth()?this.picker.find(".next").css({visibility:"hidden"}):this.picker.find(".next").css({visibility:"visible"});break;case 1:case 2:-Infinity!==this.startDate&&b<=this.startDate.getFullYear()?this.picker.find(".prev").css({visibility:"hidden"}):this.picker.find(".prev").css({visibility:"visible"}),Infinity!==this.endDate&&b>=this.endDate.getFullYear()?this.picker.find(".next").css({visibility:"hidden"}):this.picker.find(".next").css({visibility:"visible"})}},click:function(a){a.stopPropagation();
a.preventDefault();a=d(a.target).closest("span, td, th");if(1==a.length)switch(a[0].nodeName.toLowerCase()){case "th":switch(a[0].className){case "switch":this.showMode(1);break;case "prev":case "next":var b=g.modes[this.viewMode].navStep*("prev"==a[0].className?-1:1);switch(this.viewMode){case 0:this.viewDate=this.moveMonth(this.viewDate,b);break;case 1:case 2:this.viewDate=this.moveYear(this.viewDate,b)}this.fill()}break;case "span":if(!a.is(".disabled")){this.viewDate.setDate(1);if(a.is(".month")){var c=
a.parent().find("span").index(a);this.viewDate.setMonth(c);this.element.trigger({type:"changeMonth",date:this.viewDate})}else{var e=parseInt(a.text(),10)||0;this.viewDate.setFullYear(e);this.element.trigger({type:"changeYear",date:this.viewDate})}this.showMode(-1);this.fill()}break;case "td":if(a.is(".day")&&!a.is(".disabled")){var l=parseInt(a.text(),10)||1,e=this.viewDate.getFullYear(),c=this.viewDate.getMonth();a.is(".old")?0==c?(c=11,e-=1):c-=1:a.is(".new")&&(11==c?(c=0,e+=1):c+=1);this.date=
new Date(e,c,l,0,0,0,0);this.viewDate=new Date(e,c,l,0,0,0,0);this.fill();this.setValue();this.element.trigger({type:"changeDate",date:this.date});this.isInput?b=this.element:this.component&&(b=this.element.find("input"));b&&(b.change(),this.autoclose&&b.blur())}}},mousedown:function(a){a.stopPropagation();a.preventDefault()},moveMonth:function(a,b){if(!b)return a;var c=new Date(a.valueOf()),e=c.getDate(),d=c.getMonth(),j=Math.abs(b),k;b=0<b?1:-1;if(1==j){if(j=-1==b?function(){return c.getMonth()==
d}:function(){return c.getMonth()!=k},k=d+b,c.setMonth(k),0>k||11<k)k=(k+12)%12}else{for(var f=0;f<j;f++)c=this.moveMonth(c,b);k=c.getMonth();c.setDate(e);j=function(){return k!=c.getMonth()}}for(;j();)c.setDate(--e),c.setMonth(k);return c},moveYear:function(a,b){return this.moveMonth(a,12*b)},dateWithinRange:function(a){return a>=this.startDate&&a<=this.endDate},keydown:function(a){if(this.picker.is(":not(:visible)"))27==a.keyCode&&this.show();else{var b=!1,c,e,d;switch(a.keyCode){case 27:this.hide();
a.preventDefault();break;case 37:case 39:if(!this.keyboardNavigation)break;c=37==a.keyCode?-1:1;a.ctrlKey?(e=this.moveYear(this.date,c),d=this.moveYear(this.viewDate,c)):a.shiftKey?(e=this.moveMonth(this.date,c),d=this.moveMonth(this.viewDate,c)):(e=new Date(this.date),e.setDate(this.date.getDate()+c),d=new Date(this.viewDate),d.setDate(this.viewDate.getDate()+c));this.dateWithinRange(e)&&(this.date=e,this.viewDate=d,this.setValue(),this.update(),a.preventDefault(),b=!0);break;case 38:case 40:if(!this.keyboardNavigation)break;
c=38==a.keyCode?-1:1;a.ctrlKey?(e=this.moveYear(this.date,c),d=this.moveYear(this.viewDate,c)):a.shiftKey?(e=this.moveMonth(this.date,c),d=this.moveMonth(this.viewDate,c)):(e=new Date(this.date),e.setDate(this.date.getDate()+7*c),d=new Date(this.viewDate),d.setDate(this.viewDate.getDate()+7*c));this.dateWithinRange(e)&&(this.date=e,this.viewDate=d,this.setValue(),this.update(),a.preventDefault(),b=!0);break;case 13:this.hide(),a.preventDefault()}if(b){this.element.trigger({type:"changeDate",date:this.date});
var j;this.isInput?j=this.element:this.component&&(j=this.element.find("input"));j&&j.change()}}},showMode:function(a){a&&(this.viewMode=Math.max(0,Math.min(2,this.viewMode+a)));this.picker.find(">div").hide().filter(".datepicker-"+g.modes[this.viewMode].clsName).show();this.updateNavArrows()}};d.fn.datepicker=function(a){var b=Array.apply(null,arguments);b.shift();return this.each(function(){var c=d(this),e=c.data("datepicker"),l="object"==typeof a&&a;e||c.data("datepicker",e=new m(this,d.extend({},
d.fn.datepicker.defaults,l)));"string"==typeof a&&"function"==typeof e[a]&&e[a].apply(e,b)})};d.fn.datepicker.defaults={};d.fn.datepicker.Constructor=m;var n=d.fn.datepicker.dates={en:{days:"Sunday Monday Tuesday Wednesday Thursday Friday Saturday Sunday".split(" "),daysShort:"Sun Mon Tue Wed Thu Fri Sat Sun".split(" "),daysMin:"Su Mo Tu We Th Fr Sa Su".split(" "),months:"January February March April May June July August September October November December".split(" "),monthsShort:"Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec".split(" ")}},
g={modes:[{clsName:"days",navFnc:"Month",navStep:1},{clsName:"months",navFnc:"FullYear",navStep:1},{clsName:"years",navFnc:"FullYear",navStep:10}],isLeapYear:function(a){return 0===a%4&&0!==a%100||0===a%400},getDaysInMonth:function(a,b){return[31,g.isLeapYear(a)?29:28,31,30,31,30,31,31,30,31,30,31][b]},validParts:/dd?|mm?|MM?|yy(?:yy)?/g,nonpunctuation:/[^ -\/:-@\[-`{-~\t\n\r]+/g,parseFormat:function(a){var b=a.replace(this.validParts,"\x00").split("\x00");a=a.match(this.validParts);if(!b||!b.length||
!a||0==a.length)throw Error("Invalid date format.");return{separators:b,parts:a}},parseDate:function(a,b,c){if(a instanceof Date)return a;if(/^[-+]\d+[dmwy]([\s,]+[-+]\d+[dmwy])*$/.test(a)){var e=/([-+]\d+)([dmwy])/,l=a.match(/([-+]\d+)([dmwy])/g),j,k;a=new Date;for(var f=0;f<l.length;f++)switch(j=e.exec(l[f]),k=parseInt(j[1]),j[2]){case "d":a.setDate(a.getDate()+k);break;case "m":a=m.prototype.moveMonth.call(m.prototype,a,k);break;case "w":a.setDate(a.getDate()+7*k);break;case "y":a=m.prototype.moveYear.call(m.prototype,
a,k)}return new Date(a.getFullYear(),a.getMonth(),a.getDate(),0,0,0)}l=a&&a.match(this.nonpunctuation)||[];a=new Date;e={};k="yyyy yy M MM m mm d dd".split(" ");var h={yyyy:function(a,b){return a.setFullYear(b)},yy:function(a,b){return a.setFullYear(2E3+b)},m:function(a,b){for(b-=1;0>b;)b+=12;b%=12;for(a.setMonth(b);a.getMonth()!=b;)a.setDate(a.getDate()-1);return a},d:function(a,b){return a.setDate(b)}},g;h.M=h.MM=h.mm=h.m;h.dd=h.d;a=new Date(a.getFullYear(),a.getMonth(),a.getDate(),0,0,0);if(l.length==
b.parts.length){for(var f=0,s=b.parts.length;f<s;f++){g=parseInt(l[f],10);j=b.parts[f];if(isNaN(g))switch(j){case "MM":g=d(n[c].months).filter(function(){var a=this.slice(0,l[f].length),b=l[f].slice(0,a.length);return a==b});g=d.inArray(g[0],n[c].months)+1;break;case "M":g=d(n[c].monthsShort).filter(function(){var a=this.slice(0,l[f].length),b=l[f].slice(0,a.length);return a==b}),g=d.inArray(g[0],n[c].monthsShort)+1}e[j]=g}for(f=0;f<k.length;f++)if(j=k[f],j in e)h[j](a,e[j])}return a},formatDate:function(a,
b,c){c={d:a.getDate(),m:a.getMonth()+1,M:n[c].monthsShort[a.getMonth()],MM:n[c].months[a.getMonth()],yy:a.getFullYear().toString().substring(2),yyyy:a.getFullYear()};c.dd=(10>c.d?"0":"")+c.d;c.mm=(10>c.m?"0":"")+c.m;a=[];for(var e=d.extend([],b.separators),g=0,j=b.parts.length;g<j;g++)e.length&&a.push(e.shift()),a.push(c[b.parts[g]]);return a.join("")},headTemplate:'<thead><tr><th class="prev"><i class="icon-arrow-left"/></th><th colspan="5" class="switch"></th><th class="next"><i class="icon-arrow-right"/></th></tr></thead>',
contTemplate:'<tbody><tr><td colspan="7"></td></tr></tbody>'};g.template='<div class="datepicker dropdown-menu"><div class="datepicker-days"><table class=" table-condensed">'+g.headTemplate+'<tbody></tbody></table></div><div class="datepicker-months"><table class="table-condensed">'+g.headTemplate+g.contTemplate+'</table></div><div class="datepicker-years"><table class="table-condensed">'+g.headTemplate+g.contTemplate+"</table></div></div>"}(window.jQuery);